## qrtr 1.0

=== Makefile ===
proj := qrtr
proj-major := 1
proj-minor := 0
proj-version := $(proj-major).$(proj-minor)

CFLAGS := -Wall -g
LDFLAGS :=

prefix := /usr/local
bindir := $(prefix)/bin
libdir := $(prefix)/lib
includedir := $(prefix)/include
servicedir := $(prefix)/lib/systemd/system

ifneq ($(CROSS_COMPILE),)
CC := $(CROSS_COMPILE)gcc
endif
SFLAGS := -I$(shell $(CC) -print-file-name=include) -Wno-non-pointer-null

$(proj)-cfg-srcs := \
	lib/logging.c \
	src/addr.c \
	src/cfg.c \

$(proj)-cfg-cflags := -Ilib

$(proj)-ns-srcs := \
	lib/logging.c \
	src/addr.c \
	src/ns.c \
	src/map.c \
	src/hash.c \
	src/waiter.c \
	src/util.c \

$(proj)-ns-cflags := -Ilib

$(proj)-lookup-srcs := \
	lib/logging.c \
	src/lookup.c \
	src/util.c \

$(proj)-lookup-cflags := -Ilib

lib$(proj).so-srcs := \
	lib/logging.c \
	lib/qrtr.c \
	lib/qmi.c

lib$(proj).so-cflags := -fPIC -Isrc

targets := $(proj)-ns $(proj)-cfg $(proj)-lookup lib$(proj).so

out := out
src_to_obj = $(patsubst %.c,$(out)/obj/%.o,$(1))
src_to_dep = $(patsubst %.c,$(out)/dep/%.d,$(1))

all-srcs :=
all-objs :=
all-deps :=
all-clean := $(out)
all-install :=

all: $(targets)

$(out)/obj/%.o: %.c
ifneq ($C,)
	@echo "CHECK	$<"
	@sparse $< $(patsubst -iquote=%,-I%,$(CFLAGS)) $(SFLAGS)
endif
	@echo "CC	$<"
	@$(CC) -MM -MF $(call src_to_dep,$<) -MP -MT "$@ $(call src_to_dep,$<)" $(CFLAGS) $(_CFLAGS) $<
	@$(CC) -o $@ -c $< $(CFLAGS) $(_CFLAGS)

define add-inc-target
$(DESTDIR)$(includedir)/$2: $1/$2
	@echo "INSTALL	$$<"
	@install -D -m 755 $$< $$@

all-install += $(DESTDIR)$(includedir)/$2
endef

define add-target-deps
all-srcs += $($1-srcs)
all-objs += $(call src_to_obj,$($1-srcs))
all-deps += $(call src_to_dep,$($1-srcs))
all-clean += $1
$(call src_to_obj,$($1-srcs)): _CFLAGS := $($1-cflags)
endef

define add-bin-target

$(call add-target-deps,$1)

$1: $(call src_to_obj,$($1-srcs))
	@echo "LD	$$@"
	$$(CC) -o $$@ $$(filter %.o,$$^) $(LDFLAGS)

$(DESTDIR)$(bindir)/$1: $1
	@echo "INSTALL	$$<"
	@install -D -m 755 $$< $$@

all-install += $(DESTDIR)$(bindir)/$1
endef

define add-lib-target

$(call add-target-deps,$1)

$1: $(call src_to_obj,$($1-srcs))
	@echo "LD	$$@"
	$$(CC) -o $$@ $$(filter %.o,$$^) $(LDFLAGS) -shared -Wl,-soname,$1.$(proj-major)

$(DESTDIR)$(libdir)/$1.$(proj-version): $1
	@echo "INSTALL	$$<"
	@install -D -m 755 $$< $$@
	@ln -sf $1.$(proj-version) $(DESTDIR)$(libdir)/$1.$(proj-major)
	@ln -sf $1.$(proj-major) $(DESTDIR)$(libdir)/$1

all-install += $(DESTDIR)$(libdir)/$1.$(proj-version)
endef

define add-systemd-service-target
$1: $1.in
	sed 's+QRTR_NS_PATH+$(bindir)+g' $$< > $$@

$(DESTDIR)$(servicedir)/$1: $1
	@echo "INSTALL	$$<"
	@install -D -m 644 $$< $$@

all-install += $(DESTDIR)$(servicedir)/$1
endef

$(foreach v,$(filter-out %.so,$(targets)),$(eval $(call add-bin-target,$v)))
$(foreach v,$(filter %.so,$(targets)),$(eval $(call add-lib-target,$v)))
$(eval $(call add-inc-target,lib,libqrtr.h))
$(eval $(call add-systemd-service-target,qrtr-ns.service))

install: $(all-install)

clean:
	@echo CLEAN
	@$(RM) -r $(all-clean)

$(call src_to_obj,$(all-srcs)): Makefile

ifneq ("$(MAKECMDGOALS)","clean")
cmd-goal-1 := $(shell mkdir -p $(sort $(dir $(all-objs) $(all-deps))))
-include $(all-deps)
endif

## qrtr 0.3+git20201207

=== debian/changelog ===
qrtr (0.3+git20201207-2) unstable; urgency=medium

  * Source-only upload

 -- Arnaud Ferraris <aferraris@debian.org>  Mon, 11 Jul 2022 13:34:56 +0200

qrtr (0.3+git20201207-1) unstable; urgency=medium

  * Initial Debian packaging (Closes: #1011423)

 -- Arnaud Ferraris <aferraris@debian.org>  Wed, 29 Jun 2022 23:55:48 +0200

=== debian/control ===
Source: qrtr
Section: net
Priority: optional
Maintainer: DebianOnMobile Maintainers <debian-on-mobile-maintainers@alioth-lists.debian.net>
Uploaders: Arnaud Ferraris <aferraris@debian.org>
Standards-Version: 4.6.1
Build-Depends: debhelper-compat (= 13),
Homepage: https://github.com/andersson/qrtr
Vcs-Git: https://salsa.debian.org/DebianOnMobile-team/qrtr.git
Vcs-Browser: https://salsa.debian.org/DebianOnMobile-team/qrtr
Rules-Requires-Root: no

Package: libqrtr1
Section: libs
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Userspace reference for QRTR -- shared libraries
 QRTR is Qualcomm's IPC Router protocol, used for communicating with
 services provided by remote processors. It is mandatory for taking
 advantage of most features of recent Qualcomm SoCs, such as Wi-Fi,
 cellular modem, sensors...
 .
 This package contains the shared library provided by the reference
 userspace implementation of this protocol.

Package: libqrtr-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libqrtr1 (= ${binary:Version}),
Description: Userspace reference for QRTR -- development files
 QRTR is Qualcomm's IPC Router protocol, used for communicating with
 services provided by remote processors. It is mandatory for taking
 advantage of most features of recent Qualcomm SoCs, such as Wi-Fi,
 cellular modem, sensors...
 .
 This package contains the development files.

Package: qrtr-tools
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Userspace reference for QRTR -- tools and services
 QRTR is Qualcomm's IPC Router protocol, used for communicating with
 services provided by remote processors. It is mandatory for taking
 advantage of most features of recent Qualcomm SoCs, such as Wi-Fi,
 cellular modem, sensors...
 .
 This package contains the userspace tools and services provided by
 the reference userspace implementation of this protocol.

## qrtr 1.0

=== debian/changelog ===
qrtr (1.0-2) unstable; urgency=medium

  * qrtr-tools: install service file under `/lib/systemd`
    `debhelper` looks for service files under `/lib/systemd`, but ignores
    those installed under `/usr/lib/systemd`, so we need to install our
    service file to the former location to have it auto-enabled on install.

 -- Arnaud Ferraris <aferraris@debian.org>  Tue, 10 Jan 2023 23:38:33 +0100

qrtr (1.0-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Apply multi-arch hints. + libqrtr1: Add Multi-Arch: same.
    Changes-By: apply-multiarch-hints

  [ Arnaud Ferraris ]
  * New upstream version 1.0
  * d/control: bump Standards-Version, no change required

 -- Arnaud Ferraris <aferraris@debian.org>  Tue, 03 Jan 2023 09:51:05 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: DebianOnMobile Maintainers <debian-on-mobile-maintainers@alioth-lists.debian.net>
 Uploaders: Arnaud Ferraris <aferraris@debian.org>
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Build-Depends: debhelper-compat (= 13),
 Homepage: https://github.com/andersson/qrtr
 Vcs-Git: https://salsa.debian.org/DebianOnMobile-team/qrtr.git
@@ -15,6 +15,7 @@
 Architecture: any
 Depends: ${misc:Depends},
          ${shlibs:Depends},
+Multi-Arch: same
 Description: Userspace reference for QRTR -- shared libraries
  QRTR is Qualcomm's IPC Router protocol, used for communicating with
  services provided by remote processors. It is mandatory for taking

=== debian/rules ===
#!/usr/bin/make -f

export DPKG_GENSYMBOLS_CHECK_LEVEL=4
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

include /usr/share/dpkg/buildflags.mk

export QRTR_BUILD_OPTS=prefix=/usr libdir=/usr/lib/$(DEB_HOST_MULTIARCH)

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- $(QRTR_BUILD_OPTS) CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)"

override_dh_auto_install:
	dh_auto_install -- $(QRTR_BUILD_OPTS)

=== debian/watch ===
version=4
opts=filenamemangle=s%.+/v?(\d\S+)\.tar\.gz%qrtr-$1\.tar\.gz% \
   https://github.com/andersson/qrtr/tags .*/v?(\d\S+)\.tar\.gz

## qrtr 1.1

=== meson_options.txt ===
option('qrtr-ns',
  type: 'feature',
  value: 'auto',
  description: 'Whether or not to build the qrtr-ns binary'
)

option('systemd-unit-prefix',
  type: 'string',
  description: 'Directory for systemd system unit files'
)

option('systemd-service',
  type: 'feature',
  value: 'auto',
  description: 'Whether or not the systemd service should be built'
)

=== debian/changelog ===
qrtr (1.1-2) unstable; urgency=medium

  * debian: update references to upstream URL.
    This project is now part of the `linux-msm` group on GitHub, and its
    main maintainer is now Konrad Dybcio.
  * d/copyright: add copyright information for new files
  * debian: add udeb package.
    This makes it possible to include this package in debian-installer
    images, allowing users to use remote processors (e.g. WiFi) when running
    on Qualcomm-based hardware.

 -- Arnaud Ferraris <aferraris@debian.org>  Mon, 03 Feb 2025 17:11:23 +0100

qrtr (1.1-1) unstable; urgency=medium

  * New upstream version
  * d/patches: drop obsolete patches
  * d/control: add missing build-deps.
    The build system changed to `meson`, so we need a few additional build
    dependencies.
  * d/rules: stop overriding build/install commands.
    This was needed with the manually crafted makefile, but `meson` is saner
    and gets the needed bits from env. Additionally, a few options need to
    be manually enabled for the `systemd` service and `qrtr-ns` to be built.
  * d/install: add .pc file and use DEB_HOST_MULTIARCH.
    This new version now ships a pkgconfig file, so let's ship it as part of
    `libqrtr-dev`.
    Take this opportunity to replace the ugly `usr/lib/*/` wildcard with the
    proper `${DEB_HOST_MULTIARCH}` variable.
  * d/patches: restore libqrtr SONAME.
    The previous version of `libqrtr` had `libqrtr.so.1` as their SONAME,
    while the current version have only `libqrtr.so`. This is problematic as
    previously built binaries using this lib will have to be rebuilt for
    this new version.
    Restore the previous SONAME so things keep working as expected.

 -- Arnaud Ferraris <aferraris@debian.org>  Tue, 23 Apr 2024 16:09:58 +0200

qrtr (1.0-3) unstable; urgency=medium

  * Upload to unstable

 -- Arnaud Ferraris <aferraris@debian.org>  Tue, 02 Jan 2024 09:20:07 +0100

qrtr (1.0-3~exp1) experimental; urgency=medium

  * d/patches: add missing service file to the `clean` target (Closes: #1045729)
  * d/gbp.conf: use 'debian/experimental' as debian branch
  * debian: keep systemd service under /usr.
    In the current state of the Debian "/usr merge", we are allowed to move
    systemd services under `/usr/lib/systemd` when relying on
    `dh_installsystemd`. This requires adding a versioned dependency on
    `debhelper`.
    Let's comply by installing `/usr/lib/systemd` to `/usr/lib` instead of
    `/lib` previously.

 -- Arnaud Ferraris <aferraris@debian.org>  Mon, 30 Oct 2023 17:19:45 +0100

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,14 @@
 Priority: optional
 Maintainer: DebianOnMobile Maintainers <debian-on-mobile-maintainers@alioth-lists.debian.net>
 Uploaders: Arnaud Ferraris <aferraris@debian.org>
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Build-Depends: debhelper-compat (= 13),
-Homepage: https://github.com/andersson/qrtr
+               debhelper (>= 13.11.6),
+               meson,
+               ninja-build,
+               pkgconf,
+               systemd-dev,
+Homepage: https://github.com/linux-msm/qrtr
 Vcs-Git: https://salsa.debian.org/DebianOnMobile-team/qrtr.git
 Vcs-Browser: https://salsa.debian.org/DebianOnMobile-team/qrtr
 Rules-Requires-Root: no
@@ -23,6 +28,24 @@
  cellular modem, sensors...
  .
  This package contains the shared library provided by the reference
+ userspace implementation of this protocol.
+
+Package: libqrtr1-udeb
+Build-Profiles: <!noudeb>
+Package-Type: udeb
+Section: debian-installer
+Architecture: any
+Depends: ${misc:Depends},
+         ${shlibs:Depends}
+Description: Userspace reference for QRTR -- minimal runtime
+ This is a udeb, or a microdeb, for the debian-installer.
+ .
+ QRTR is Qualcomm's IPC Router protocol, used for communicating with
+ services provided by remote processors. It is mandatory for taking
+ advantage of most features of recent Qualcomm SoCs, such as Wi-Fi,
+ cellular modem, sensors...
+ .
+ This package contains the minimal runtime library for the reference
  userspace implementation of this protocol.
 
 Package: libqrtr-dev
@@ -51,3 +74,21 @@
  .
  This package contains the userspace tools and services provided by
  the reference userspace implementation of this protocol.
+
+Package: qrtr-tools-udeb
+Build-Profiles: <!noudeb>
+Package-Type: udeb
+Section: debian-installer
+Architecture: any
+Depends: ${misc:Depends},
+         ${shlibs:Depends},
+Description: Userspace reference for QRTR -- minimal tools and services
+ This is a udeb, or a microdeb, for the debian-installer.
+ .
+ QRTR is Qualcomm's IPC Router protocol, used for communicating with
+ services provided by remote processors. It is mandatory for taking
+ advantage of most features of recent Qualcomm SoCs, such as Wi-Fi,
+ cellular modem, sensors...
+ .
+ This package contains the minimal tools and services provided by
+ the reference userspace implementation of this protocol.

=== debian/rules ===
#!/usr/bin/make -f

export DPKG_GENSYMBOLS_CHECK_LEVEL=4
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -Dqrtr-ns=enabled -Dsystemd-service=enabled

## qrtr 1.2

=== debian/changelog ===
qrtr (1.2-1) unstable; urgency=medium

  * New upstream version
  * d/patches: drop upstreamed patches
  * d/watch: convert to version 5
  * d/control: drop Rules-Requires-Root.
    This is now unneeded. Also bump Standards-Version as no other change is
    needed.

 -- Arnaud Ferraris <aferraris@debian.org>  Mon, 15 Dec 2025 11:18:59 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: DebianOnMobile Maintainers <debian-on-mobile-maintainers@alioth-lists.debian.net>
 Uploaders: Arnaud Ferraris <aferraris@debian.org>
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Build-Depends: debhelper-compat (= 13),
                debhelper (>= 13.11.6),
                meson,
@@ -13,11 +13,10 @@
 Homepage: https://github.com/linux-msm/qrtr
 Vcs-Git: https://salsa.debian.org/DebianOnMobile-team/qrtr.git
 Vcs-Browser: https://salsa.debian.org/DebianOnMobile-team/qrtr
-Rules-Requires-Root: no
 
 Package: libqrtr1
 Section: libs
-Architecture: any
+Architecture: amd64 armhf arm64
 Depends: ${misc:Depends},
          ${shlibs:Depends},
 Multi-Arch: same
@@ -34,7 +33,7 @@
 Build-Profiles: <!noudeb>
 Package-Type: udeb
 Section: debian-installer
-Architecture: any
+Architecture: amd64 armhf arm64
 Depends: ${misc:Depends},
          ${shlibs:Depends}
 Description: Userspace reference for QRTR -- minimal runtime
@@ -50,7 +49,7 @@
 
 Package: libqrtr-dev
 Section: libdevel
-Architecture: any
+Architecture: amd64 armhf arm64
 Depends: ${misc:Depends},
          ${shlibs:Depends},
          libqrtr1 (= ${binary:Version}),
@@ -63,7 +62,7 @@
  This package contains the development files.
 
 Package: qrtr-tools
-Architecture: any
+Architecture: amd64 armhf arm64
 Depends: ${misc:Depends},
          ${shlibs:Depends},
 Description: Userspace reference for QRTR -- tools and services
@@ -79,7 +78,7 @@
 Build-Profiles: <!noudeb>
 Package-Type: udeb
 Section: debian-installer
-Architecture: any
+Architecture: amd64 armhf arm64
 Depends: ${misc:Depends},
          ${shlibs:Depends},
 Description: Userspace reference for QRTR -- minimal tools and services
